import{forwardRef as e,useRef as t,useState as r,useEffect as n,createElement as o,useMemo as i,useCallback as c}from"react";import l from"react-merge-refs";
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */const s=["direction","padding","paddingTop","paddingBottom","paddingLeft","paddingRight","margin","marginTop","marginBottom","marginLeft","marginRight","border","borderWidth","borderTopWidth","borderBottomWidth","borderLeftWidth","borderRightWidth","borderStyle","borderTopStyle","borderBottomStyle","borderLeftStyle","borderRightStyle","fontSize","fontFamily","fontStyle","fontVariant","fontWeight","fontStretch","fontSizeAdjust","textAlign","textTransform","textIndent","letterSpacing","wordSpacing","lineHeight","whiteSpace","wordBreak","overflowWrap","tabSize","MozTabSize"],a=(e,t)=>{const r=e.getPropertyValue(t);return r?parseInt(r,10):0},d=e=>a(e,"padding-top")+a(e,"padding-bottom")+a(e,"border-top")+a(e,"border-bottom"),u=e=>a(e,"padding-left")+a(e,"padding-right")+a(e,"border-left")+a(e,"border-right"),p=e(((e,a)=>{var{children:p,style:g,onScroll:b}=e,h=function(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(n=Object.getOwnPropertySymbols(e);o<n.length;o++)t.indexOf(n[o])<0&&Object.prototype.propertyIsEnumerable.call(e,n[o])&&(r[n[o]]=e[n[o]])}return r}(e,["children","style","onScroll"]);const f=t(null),y=t(null),[[S,m],v]=r([0,0]),[[O,w,x,j],k]=r([0,0,0,0]),T=t("");n((()=>{if(!f.current)return;const e=new ResizeObserver((e=>{if(!f.current)return;const t=window.getComputedStyle(f.current);k([e[0].contentRect.width,e[0].contentRect.height,u(t),d(t)])}));return e.observe(f.current),()=>{e.disconnect()}}),[]),n((()=>{var e;if(!y.current||!f.current)return;const t=window.getComputedStyle(f.current);T.current||(T.current=t.getPropertyValue("color")),((e,t,r)=>{e.forEach((e=>{t[e]=r[e]}))})(s,y.current.style,t),f.current.style.color="transparent",f.current.style.caretColor=null!==(e=null==g?void 0:g.caretColor)&&void 0!==e?e:T.current,y.current.style.borderColor="transparent"}),[g]);const z=O+x,W=w+j;return o("div",{style:i((()=>({display:"inline-block",position:"relative",width:z,height:W})),[z,W])},o("div",{style:i((()=>{const e={position:"absolute",overflow:"hidden",top:0,left:0,zIndex:-1,width:z,height:W};return g?(g.background&&(e.background=g.background),g.backgroundColor&&(e.backgroundColor=g.backgroundColor),e):e}),[z,W])},o("div",{ref:y,"aria-hidden":!0,style:i((()=>({width:O,transform:`translate(${-S}px, ${-m}px)`,pointerEvents:"none",userSelect:"none",msUserSelect:"none",WebkitUserSelect:"none",textSizeAdjust:"100%",WebkitTextSizeAdjust:"100%"})),[S,m,O,g])},i((()=>p(String(h.value))),[h.value,p]))),o("textarea",Object.assign(Object.assign({},h),{ref:i((()=>l([f,a])),[f,a]),style:i((()=>Object.assign(Object.assign({},g),{background:"transparent",margin:0,position:"absolute"})),[g]),onScroll:c((e=>{v([e.currentTarget.scrollLeft,e.currentTarget.scrollTop]),null==b||b(e)}),[b])})))})),g=e=>t=>{const r={},n=[];e.forEach((([e,o],i)=>{n.push(...((e,t)=>{const r=[];let n=e.exec(t);for(;n;)r.push(n),n=e.exec(t);return r})(e,t).map((e=>[e.index,e.index+e[0].length,i]))),r[String(i)]=o}));const i=(e=>{e.sort(((e,t)=>e[0]-t[0]||e[1]-t[1]));const t=[];let r;return e.forEach((([e,n,o])=>{if(!r||e>=r[1])t.push(r=[e,n,{[o]:!0}]);else if(n>r[1])r[2][o]=!0,t.push(r=[r[1],n,{[o]:!0}]);else if(n<=r[1]){const i=r[1],c=Object.assign({},r[2]),l=Object.assign({},r[2]);r[0]!==e?r[1]=e:t.pop(),c[o]=!0,t.push(r=[e,n,c]),n!==i&&t.push(r=[n,i,l])}})),t})(n),c=[];let l=0;for(let e=0;e<i.length;e++){const[n,s,a]=i[e];c.push(t.slice(l,n));const d=Object.keys(a).reduce(((e,t)=>{const n=r[t];return Object.keys(n).forEach((t=>{e[t]=n[t]})),e}),{});c.push(o("span",{key:e,style:d},t.slice(n,s))),l=s}return c.push(t.slice(l)),c};export{p as Textarea,g as createRegexRenderer};
